
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class ToyotaCarSaleApp {

    public static void main(String[] args) throws FileNotFoundException {
        // OPEN FILES
        // Input File:
        File inputFile = new File("input.txt");// reading data 

        if (!inputFile.exists()) {
            System.out.println("Input file, " + inputFile + ", does not exist.");
            System.exit(0);
        }
        File fileW = new File("print.txt");// file pointer to Write file
        
        PrintWriter fWrite = new PrintWriter(fileW); // creating Object to write data in file
        fWrite.println("\n\tWelcome to Toyota Car Sale App  System!\n");

        // Make Scanner for input 
        Scanner input = new Scanner(inputFile);
        
        
        String[] city = new String[input.nextInt()]; // first read from file total City which is 3 in our case and creating array structure.
        String[][] branch = new String[city.length][]; // creating array structure for branch of each city
        
        for (int i = 0; i < city.length; i++) {
            branch[i] = new String[input.nextInt()]; // creating array structure of total branch for each city : jeddah makkah madina

        }
        
        String[] months = new String[input.nextInt()]; // creating array structure to store sales record detail
        
        int[][][] sales = new int[city.length][][];
        for (int i = 0; i < branch.length; i++) {// creating array structure to store sales record for each city 
            sales[i] = new int[branch[i].length][months.length];
        }

        // reading data from the file
        String command = null;
        do {
            command = input.next();
            // Command Add_City: Add City records in array
            if (command.equalsIgnoreCase("Add_City")) {
                addCity(city, input, fWrite);
            } // Add_Branch_City: Add City Branch records in array
            else if (command.equalsIgnoreCase("Add_City_Branch")) {
                addBranch(branch, city, input, fWrite);
            } else if (command.equalsIgnoreCase("Add_Month")) {
                addMonth(months, input, fWrite);
            } else if (command.equalsIgnoreCase("Add_Sales")) {
                addSalesRecord(branch, sales, city, months, input, fWrite);
            } else if (command.equalsIgnoreCase("Print_Total_Sales_Branch")) {
                printSalesBranch(branch, sales, city, fWrite);
            } else if (command.equalsIgnoreCase("Print_Total_Sales_Month")) {
                printSalesMonth(city, sales, months, fWrite);
            } 
        } while (!command.equalsIgnoreCase("Quit"));

        fWrite.println("\nThank you for using Toyota Car Sale App, Good Bye!");
        fWrite.flush(); // immediately save in the file
        fWrite.close(); // closing file write object
        input.close();// closing file read object
        System.out.println("Done!, check output files!!!");
    }

    //--------------------------------------------------------------------------------------------------------------------
    // Add City in the system
    public static void addCity(String[] city, Scanner input, PrintWriter output) {
        output.println("Command: Add_City".toUpperCase());
        output.println("***Following City names are recorded in the system - Toyota Car Sale App System - ***");
        output.println();
        output.println(" City Names: ");
        for (int i = 0; i < city.length; i++) {
            city[i] = input.next();
            output.print("\t" + city[i].toUpperCase());
        }
        output.println("\n-------------------------------------------------------------------------------------------------------");
        output.println();
    }// Add City in the system ends here
    //--------------------------------------------------------------------------------------------------------------------
    // Add Branch in the system

    public static void addBranch(String[][] branch, String[] city, Scanner input, PrintWriter output) {
        output.println("Command: Add_Branch".toUpperCase());
        output.println("***Following branch names are recorded in the system  - Toyota Car Sale App System - ***");
        output.println();

        for (int i = 0; i < branch.length; i++) {
            output.println(city[i].toUpperCase());
            for (int j = 0; j < branch[i].length; j++) {
                branch[i][j] = input.next();
                output.print("\t" + branch[i][j].toUpperCase());
            }
            output.println();
        }
        output.println("\n-------------------------------------------------------------------------------------------------------");
        output.println();
    }   // Add Branch in the system ends here

    //--------------------------------------------------------------------------------------------------------------------
    // Add Months in the system
    public static void addMonth(String[] month, Scanner input, PrintWriter output) {
        output.println("Command: Add_Month".toUpperCase());
        output.println("***Following month names are recorded in the system - Toyota Car Sale App System - ***");
        output.println();
        output.println(" Month Names: ");
        for (int i = 0; i < month.length; i++) {
            month[i] = input.next();
            output.print(month[i].toUpperCase() + ", ");
        }
        output.println("\n-------------------------------------------------------------------------------------------------------");
        output.println();
    }// Add Month in the system ends here
    //--------------------------------------------------------------------------------------------------------------------
    // Add sales in the system

    public static void addSalesRecord(String[][] branch, int[][][] sales, String[] city,
            String[] month, Scanner input, PrintWriter output) {
        output.println("Command: Add_Sales".toUpperCase());
        output.println("***Following Sales Figures are recorded in the system - Toyota Car Sale App System - ***");
        for (int i = 0; i < sales.length; i++) {
            output.println("\n-------------------------------------------------------------------------------------------------------");
            output.print("\n***For the City : " + city[i] + "***\r\n");
            for (int j = 0; j < branch[i].length; j++) {
                output.println("\r\nBranch( " + branch[i][j] + " )");
                for (int k = 0; k < month.length; k++) {
                    sales[i][j][k] = input.nextInt();
                    output.printf("\tMonth (%9s): %6d\t", month[k], sales[i][j][k]);
                    if (k != 0 || k % 4 == 0) {
                        output.println(); // for next line , four months in one line
                    }
                }
            }

        }
        output.println();
    } // add sales ends here
    //--------------------------------------------------------------------------------------------------------------------
    // calculate total sales for each branch 

    public static void printSalesBranch(String[][] branch, int[][][] sales, String[] city,
            PrintWriter output) {
        output.println();
        output.println("Command: Print_Total_Sales_Branch".toUpperCase());
        int total;
        output.println("***Following is  Total Sales Figures based on branches recorded in the system - Toyota Car Sale App System - ***");
        for (int i = 0; i < sales.length; i++) {
            output.println("\n-------------------------------------------------------------------------------------------------------");
            output.print("\n***Total Sales Figures For the City : " + city[i] + "***\n");
            // output.println("\r\n");
            for (int j = 0; j < branch[i].length; j++) {
                total = 0;
                output.printf("\r\n\t%15s:\t", branch[i][j]);
                for (int k = 0; k < sales[i][j].length; k++) {
                    total += sales[i][j][k];
                }
                output.print(total + " SR");
            }
            output.println();
        }
    } // calculate total sales for each branch ends here

    //--------------------------------------------------------------------------------------------------------------------
    // calculate total sales for each branch 
    public static void printSalesMonth(String[] city, int[][][] sales, String[] month, PrintWriter output) {
        // solve by yourself
    } // calculate total sales for each branch ends here
//--------------------------------------------------------------------------------------------------------------------

}
